"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var fs = _interopRequireWildcard(require("fs"));

var path = _interopRequireWildcard(require("path"));

var t = _interopRequireWildcard(require("@babel/types"));

var babylon = _interopRequireWildcard(require("@babel/parser"));

var _traverse = _interopRequireDefault(require("@babel/traverse"));

var _rawLoader = _interopRequireDefault(require("./loader/rawLoader"));

var _schemaLoader = _interopRequireDefault(require("./loader/schemaLoader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var requireResolve = require('require-resolve');

var BabelInlineImportHelper =
/*#__PURE__*/
function () {
  function BabelInlineImportHelper() {
    _classCallCheck(this, BabelInlineImportHelper);
  }

  _createClass(BabelInlineImportHelper, null, [{
    key: "shouldBeInlined",
    // ['.a', '.b', '.c', { name: '.d', loader: (content) => `~~${content}~~` }]
    value: function shouldBeInlined(givenPath, extensions) {
      var accept = typeof extensions === 'string' ? [extensions] : extensions || BabelInlineImportHelper.extensions;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = accept[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var extension = _step.value;
          var ext = extension.name || extension;

          if (givenPath.endsWith(ext)) {
            return true;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return false;
    } // [ '', '', '' ]

  }, {
    key: "getLoader",
    value: function getLoader(givenPath, extensions) {
      var curr = extensions.find(function (extension) {
        var ext = extension.name || extension;
        return givenPath.endsWith(ext);
      }) || {};
      return curr.loader || _rawLoader.default;
    }
  }, {
    key: "getContents",
    value: function getContents(givenPath, reference, extensions) {
      if (!reference) {
        throw new Error('"reference" argument must be specified');
      }

      var mod = requireResolve(givenPath, path.resolve(reference));

      if (!mod || !mod.src) {
        throw new Error("Path '".concat(givenPath, "' could not be found for '").concat(reference, "'"));
      }

      var rawContent = fs.readFileSync(mod.src).toString();
      var loader = BabelInlineImportHelper.getLoader(givenPath, extensions || BabelInlineImportHelper.extensions);
      var content = loader(rawContent, mod.src);
      return BabelInlineImportHelper.astify(content);
    }
  }, {
    key: "transformRelativeToRootPath",
    value: function transformRelativeToRootPath(path, rootPathSuffix) {
      if (this.hasRoot(path)) {
        var withoutRoot = path.substring(1, path.length);
        return "".concat(BabelInlineImportHelper.root).concat(rootPathSuffix || '', "/").concat(withoutRoot);
      }

      if (typeof path === 'string') {
        return path;
      }

      throw new Error('ERROR: No path passed');
    }
  }, {
    key: "hasRoot",
    value: function hasRoot(string) {
      if (typeof string !== 'string') {
        return false;
      }

      return string.substring(0, 1) === '/';
    } // convert literal to ast

  }, {
    key: "astify",
    value: function astify(literal) {
      if (literal === null) {
        return t.nullLiteral();
      }

      switch (_typeof(literal)) {
        case 'function':
          var ast = babylon.parse(literal.toString(), {
            allowReturnOutsideFunction: true,
            allowSuperOutsideMethod: true
          });
          return _traverse.default.removeProperties(ast);

        case 'number':
          return t.numericLiteral(literal);

        case 'string':
          return t.stringLiteral(literal);

        case 'boolean':
          return t.booleanLiteral(literal);

        case 'undefined':
          return t.unaryExpression('void', t.numericLiteral(0), true);

        default:
          if (Array.isArray(literal)) {
            return t.arrayExpression(literal.map(BabelInlineImportHelper.astify));
          }

          return t.objectExpression(Object.keys(literal).filter(function (k) {
            return typeof literal[k] !== 'undefined';
          }).map(function (k) {
            return t.objectProperty(t.stringLiteral(k), BabelInlineImportHelper.astify(literal[k]));
          }));
      }
    }
  }]);

  return BabelInlineImportHelper;
}();

exports.default = BabelInlineImportHelper;
BabelInlineImportHelper.extensions = ['.raw', '.text', '.graphql', {
  name: '.schema',
  loader: _schemaLoader.default
}];
BabelInlineImportHelper.root = global.rootPath || process.cwd();